****************************************************************************
* Project:	ultraDev
* Module:	terminal example
* Code:		ultra
* Created:	23.12.2019
* Notes:	displays a terminal starting from line 16 to end of the screen
* Modified:
* Changes:
*
* (c) 2019 cream
****************************************************************************
	jmp		start

****************************************************************************
	include "UDAll.s"

****************************************************************************
start:
	
	bsr		UDCartGet68kVersion

	pea		prg(pc)
	move.w	#$0026,-(sp)
	trap	#$0e
	adda.l	#6,sp
	rts

****************************************************************************
prg:
	move	#' ',d0
	bsr		UDDbgScrClear
	move	#16,d0
	bsr		UDTermInit
	
	bsr		UDCartGet68kVersion
	move	d0,termValue1

	move	#0,d0
	move	#0,d1
	move	#7,d2
	lea		termText6,a0
	bsr		UDDbgScrPrint
.loop:
	// print some text to the terminal
	lea		termText1,a0
	lea		termValue1,a1
	lea		termValue2,a2
	lea		termValue3,a3
	lea		termValue4,a4
	lea		termValue5,a5
	bsr		UDTermPrint

	move	#2,d0
	bsr		wait
	lea		termText2,a0
	bsr		UDTermPrint
	move	#3,d0
	bsr		wait

	lea		termText3,a0
	bsr		UDTermPrint

	move	#4,d0
	bsr		wait
	lea		termText2,a0
	bsr		UDTermPrint
	move	#2,d0
	bsr		wait

	lea		termText4,a0
	bsr		UDTermPrint

	move	#1,d0
	bsr		wait
	lea		termText2,a0
	bsr		UDTermPrint
	move	#7,d0
	bsr		wait
	lea		termText5,a0
	bsr		UDTermPrint
	move	#1,d0
	bsr		wait

	bra		.loop

****************************************************************************
wait:
	mulu	#5,d0
.waitloop:
	move.l	d0,-(a7)
	move.w	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	move.l	(a7)+,d0

	dbf		d0,.waitloop
	rts
****************************************************************************
termValue1:	dc.w	$a1
termValue2:	dc.l	$deadbeef
termValue3:	dc.b	$c3
termValue4:	dc.b	$d4
termValue5:	dc.b	$e5
			even
termText1:	dc.b	"Starting up...",10,"version %w  %l %b %b",0
termText2:	dc.b	1,2,"done.",0
termText3:	dc.b	1,3,"Init hardware...",0
termText4:	dc.b	"Init some stuff.",10,"bla",0
termText5:	dc.b	"01234567890123456789012345678901234567890123456789",0
termText6:	dc.b	"ultraDev Terminal demo",10,10
			dc.b	"----------------------",10,10
			dc.b	"As you can see the upper part of the",10
			dc.b	"screen is fixed.",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"....",10
			dc.b	"--------------------------------------------------",0
